﻿'***************************************************************************************************
'   Excel関連定数(実行時バインド版)                             modAboutExcel4(Module)
'
'   作成者:井上治  URL:https://www.ne.jp/asahi/excel/inoue/ [Excelでお仕事!]
'***************************************************************************************************
'   [参照追加]・Microsoft Excel 1x.0 Object Library
'   ※この下に「Excel関連クラス(clsAboutExcel4)」があります
'***************************************************************************************************
' 変更日付 Rev     変更履歴内容-------------------------------------------------------------------->
' 17/04/16(1.0.0.0)新規作成
' 18/03/04(1.1.0.0)実行時バインド版として再作成
' 18/08/08(1.1.1.0)Excelバイナリブック(*.xlsb)の対応を追加(定数追加:xlExcel12)
'***************************************************************************************************
Imports System.IO
Imports System.Net
Imports System.Runtime.InteropServices
Imports System.Runtime.InteropServices.ComTypes
Imports Microsoft.Win32.SafeHandles
Module modAboutExcel4
    '===============================================================================================
    ' Excel処理関連定数
    Friend Const g_cnsExcelApplication As String = "Excel.Application"
    Friend Const xlCalculationAutomatic As Int16 = -4105
    Friend Const xlCalculationManual As Int16 = -4135
    Friend Const xlSheetVisible As Int16 = -1
    Friend Const xlSheetHidden As Int16 = 0
    Friend Const xlSheetVeryHidden As Int16 = 2
    Friend Const xlPasteValues As Int16 = -4163
    Friend Const xlHAlignCenter As Int16 = -4108
    Friend Const xlSolid As Int16 = 1
    Friend Const xlInsideVertical As Int16 = 11
    Friend Const xlInsideHorizontal As Int16 = 12
    Friend Const xlContinuous As Int16 = 1
    Friend Const xlHairline As Int16 = 1
    Friend Const xlThin As Int16 = 2
    Friend Const xlMedium As Int16 = -4138
    Friend Const xlThick As Int16 = 4
    Friend Const xlDouble As Int16 = -4119
    Friend Const xlEdgeLeft As Int16 = 7
    Friend Const xlEdgeRight As Int16 = 10
    Friend Const xlEdgeTop As Int16 = 8
    Friend Const xlEdgeBottom As Int16 = 9
    Friend Const xlCenter As Int16 = -4108
    Friend Const xlRight As Int16 = -4152
    Friend Const xlLeft As Int16 = -4131
    Friend Const xlTop As Int16 = -4160
    Friend Const xlBottom As Int16 = -4107
    Friend Const xlCellTypeLastCell As Int16 = 11
    Friend Const xlCellTypeFormulas As Int16 = -4123
    Friend Const xlCellTypeVisible As Int16 = 12
    Friend Const xlUp As Int16 = -4162
    Friend Const xlDown As Int16 = -4121
    Friend Const xlToLeft As Int16 = -4159
    Friend Const xlToRight As Int16 = -4161
    Friend Const xlMaximized As Int16 = -4137
    Friend Const xlMinimized As Int16 = -4140
    Friend Const xlNormal As Int16 = -4143
    Friend Const xlAscending As Int16 = 1
    Friend Const xlDescending As Int16 = 2
    Friend Const xlYes As Int16 = 1
    Friend Const xlNo As Int16 = 2
    Friend Const xlTopToBottom As Int16 = 1
    Friend Const xlCodePage As Int16 = 2
    Friend Const xlSortTextAsNumbers As Int16 = 1
    Friend Const xlAutomatic As Int16 = -4105
    Friend Const xlPortrait As Int16 = 1
    Friend Const xlLandscape As Int16 = 2
    Friend Const xlExpression As Int16 = 2
    Friend Const xlA1 As Int16 = 1
    Friend Const xlR1C1 As Int16 = -4150
    Friend Const xlPaperA4 As Int16 = 9
    '-----------------------------------------------------------------------------------------------
    ' 保存ファイル形式定数
    Friend Const xlExcel8 As Int16 = 56                         ' 旧xls形式
    Friend Const xlTemplate8 As Int16 = 17                      ' 旧xlt形式
    Friend Const xlOpenXMLWorkbook As Int16 = 51                ' xlsx形式
    Friend Const xlOpenXMLWorkbookMacroEnabled As Int16 = 52    ' xlsm形式
    Friend Const xlOpenXMLTemplate As Int16 = 54                ' xltx形式
    Friend Const xlOpenXMLTemplateMacroEnabled As Int16 = 53    ' xltm型式
    Friend Const xlAddIn8 As Int16 = 18                         ' xla型式
    Friend Const xlOpenXMLAddIn As Int16 = 55                   ' xlam型式
    Friend Const xlExcel12 As Int16 = 50                        ' xlsb形式
    '-----------------------------------------------------------------------------------------------
    ' セル収容可能文字数(矩形転記時上限)
    Friend Const g_cnsCellStringLengthMax As Integer = 911
    '-----------------------------------------------------------------------------------------------
    ' 拡張メッセージボックス用ガイド(Excel処理専用：参照系用)
    Friend ReadOnly g_tblExcelButtonText() As String = {"新規にExcelを起動して出力", _
                                                        "開いているExcelに出力", _
                                                        "キャンセル"}
    Friend ReadOnly g_cnsExcelMessageGuide As String = _
        "新規にExcelを起動して出力するか、開いている(実行中)Excelに出力するかの指定です。" & ControlChars.CrLf & _
        "｢開いているExcelに出力｣を選択してもExcelが起動していない場合は新規に起動して出力されます。" & ControlChars.CrLf & _
        "※特に指定がない場合は｢新規にExcelを起動して出力｣を選択して下さい。" & ControlChars.CrLf & _
        "※出力処理中はExcelを操作しないで下さい。"

    '---------------------------------------<< End of Source >>-------------------------------------
End Module

'***************************************************************************************************
'   Excel関連クラス(実行時バインド版)                            clsAboutExcel4(Class)
'
'   作成者:井上治  URL:https://www.ne.jp/asahi/excel/inoue/ [Excelでお仕事!]
'***************************************************************************************************
' 変更日付 Rev     変更履歴内容-------------------------------------------------------------------->
' 17/04/16(1.0.0.0)新規作成
' 17/08/15(1.0.0.1)GP_SuspendExcelProcでのClose時にBeforeCloseイベントを抑制する対応
' 18/03/04(1.1.0.0)実行時バインド版として再作成
' 18/05/16(1.1.1.0)ExcelのInteractive操作を追加する対応
'***************************************************************************************************
Friend Class clsAboutExcel4
    Implements IDisposable
    '===============================================================================================
    ' テンプレート形式拡張子
    Private Const g_cnsXlt As String = ".XLT"                   ' 97-2003形式テンプレート
    Private Const g_cnsXltm As String = ".XLTM"                 ' 2007形式テンプレート(マクロ有効)
    Private Const g_cnsXltx As String = ".XLTX"                 ' 2007形式テンプレート(マクロ無効)
    '-----------------------------------------------------------------------------------------------
    ' Field to handle multiple calls to Dispose gracefully.
    Private g_blnDisposed As Boolean = False                    ' 破棄判定
    ' SafeHandleインスタンス
    Private handle As SafeHandle = New SafeFileHandle(IntPtr.Zero, True) ' SafeHandleインスタンス
    '-----------------------------------------------------------------------------------------------
    ' MessageBoxのOwnerWindow指定のための現在フォーム
    Private g_objOwnerForm As Object = Nothing                  ' Ownerフォーム
    ' 各スイッチ
    Private g_swNewInstance As Boolean = False                  ' 新規インスタンス
    Private g_swPrintCancel As Boolean = False                  ' 処理中断スイッチ
    Private g_swExcelDuringProc As Boolean = False              ' 出力処理中スイッチ
    Private g_blnUseKeyDown As Boolean = False                  ' KeyDownイベント使用
    ' ブックOPEN時のイベント状態(イベント停止する場合はFP_GetWorkbookを呼ぶ前にFalseにする)
    Private g_swExcelEnableEvents As Boolean = True             ' [初期値]True
    ' エラーメッセージ(非表示時の取り出し用)
    Private g_strFatalErrMSG As String = ""                     ' エラーメッセージ

    '***********************************************************************************************
    ' ■■■ クラス初期化メソッド ■■■
    '***********************************************************************************************
    '* 処理名　：New
    '* 機能　　：初期化
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = Ownerフォーム(Object)
    '* 　　　　　Arg2 = KeyDownイベント使用(Boolean)        ※Option
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年04月16日
    '* 作成者　：井上　治
    '* 更新日　：2017年04月16日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：KeyDownイベント使用の時はフォームデザイナでKeyPreviewをTrueにして下さい
    '***********************************************************************************************
    Friend Sub New(ByRef objOwner As Object, _
                   Optional ByVal blnUseKeyDown As Boolean = False)
        '-------------------------------------------------------------------------------------------
        g_objOwnerForm = objOwner                               ' Ownerフォーム
        g_blnUseKeyDown = blnUseKeyDown                         ' KeyDownイベント使用
        g_swNewInstance = False
        g_swExcelEnableEvents = True
        g_swPrintCancel = False
        'g_strFatalErrMSG = String.Empty
        ' KeyDownイベント使用
        If g_blnUseKeyDown Then
            ' KeyDownイベントハンドラ追加
            AddHandler CType(objOwner, Form).KeyDown, AddressOf Form_KeyDown
        End If
    End Sub

    '***********************************************************************************************
    '   ■■■ 破棄 ■■■
    '***********************************************************************************************
    '* 処理名　：Dispose、Finalize
    '* 機能　　：クラス破棄
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：(なし)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年04月16日
    '* 作成者　：井上　治
    '* 更新日　：2017年04月16日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Friend Overloads Sub Dispose() Implements IDisposable.Dispose
        '-------------------------------------------------------------------------------------------
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

    Protected Friend Overloads Sub Dispose(ByVal blnDisposing As Boolean)
        '-------------------------------------------------------------------------------------------
        ' 既に破棄されていないか
        If Not g_blnDisposed Then
            ' Dispose呼び出しか
            If blnDisposing Then
                handle.Dispose()
                g_blnDisposed = True
            End If
            If g_blnUseKeyDown Then
                ' KeyDownイベントハンドラ開放
                RemoveHandler CType(g_objOwnerForm, Form).KeyDown, AddressOf Form_KeyDown
            End If
            ' 参照破棄
            g_objOwnerForm = Nothing
        End If
    End Sub

    '***********************************************************************************************
    ' ■■■ フォームイベント ■■■
    '***********************************************************************************************
    '* 処理名　：Form_KeyDown
    '* 機能　　：キー押下イベント(Form_KeyDown)
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：(デフォルト)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年04月16日
    '* 作成者　：井上　治
    '* 更新日　：2017年04月16日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Friend Sub Form_KeyDown(ByVal sender As Object, _
                            ByVal e As System.Windows.Forms.KeyEventArgs)
        '-------------------------------------------------------------------------------------------
        ' Escキーは中断指示とみなす
        If ((e.KeyCode = Keys.Escape) AndAlso (Not e.Shift)) Then
            ' 処理中断スイッチをセット
            g_swPrintCancel = True
        End If
    End Sub

    '***********************************************************************************************
    ' ■■■ 公開メソッド ■■■
    '***********************************************************************************************
    '* 処理名　：GetWorkbook
    '* 機能　　：Excelのインスタンスを生成してワークブックを開く
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：処理正否(Boolean)
    '* 引数　　：Arg1 = ワークブックファイル名(String)   ※フルパスで指定
    '* 　　　　　Arg2 = Excel.Application(Object)        ※Ref参照
    '* 　　　　　Arg3 = Excel.Workbook(Object)           ※Ref参照
    '* 　　　　　Arg4 = 引数UpdateLinks(Int16)           ※Option:Workbook時の引数
    '* 　　　　　Arg5 = 引数ReadOnly(Boolean)            ※Option:Workbook時の引数
    '* 　　　　　Arg6 = インスタンス生成(Boolean)        ※Option:True=新規インスタンス
    '* 　　　　　Arg7 = エラーメッセージ表示(Boolean)    ※Option:True=表示する
    '* 　　　　　Arg8 = Open時イベント状態(Boolean)      ※Option:True=イベント有効
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年04月16日
    '* 作成者　：井上　治
    '* 更新日　：2017年04月16日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：ファイルの存在確認は行ないません
    '***********************************************************************************************
    Friend Function GetWorkbook(ByVal strExcelFileName As String, _
                                ByRef objExcel As Object, _
                                ByRef objWbk As Object, _
                                Optional ByVal intUpdateLinks As Int16 = 0, _
                                Optional ByVal blnReadOnly As Boolean = True, _
                                Optional ByVal blnNewInstance As Boolean = False, _
                                Optional ByVal blnDispFatalError As Boolean = True, _
                                Optional ByVal blnEnableEvents As Boolean = True) As Boolean
        '-------------------------------------------------------------------------------------------
        Dim objWorkbooks As Object = Nothing                    ' Excel.Workbooks
        Dim blnTemplate As Boolean = False                      ' テンプレート判定
        Dim strBooknameU As String = String.Empty               ' ブック名(大文字変換)
        g_strFatalErrMSG = String.Empty
        g_swNewInstance = False
        objExcel = Nothing
        objWBK = Nothing
        '-------------------------------------------------------------------------------------------
        ' Excel.Applicationのインスタンス生成
        If Not GetExcelInstance(objExcel, blnNewInstance, blnDispFatalError) Then Return False
        '-------------------------------------------------------------------------------------------
        ' ワークブック取得
        GetWorkbook = OpenWorkbook(strExcelFileName, _
                                   objExcel, _
                                   objWorkbooks, _
                                   objWbk, _
                                   intUpdateLinks, _
                                   blnReadOnly, _
                                   blnNewInstance, _
                                   blnDispFatalError, _
                                   blnEnableEvents)
        '-------------------------------------------------------------------------------------------
        ' Workbooksオブジェクトを解放(正常時)
        Call GP_ReleaseComObject(objWorkbooks)
    End Function

    '***********************************************************************************************
    '* 処理名　：GetExcelInstance
    '* 機能　　：Excelのインスタンス生成
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：処理正否(Boolean)
    '* 引数　　：Arg1 = Excel.Application(Object)        ※Ref参照
    '* 　　　　　Arg2 = インスタンス生成(Boolean)        ※Option:True=新規インスタンス
    '* 　　　　　Arg3 = エラーメッセージ表示(Boolean)    ※Option:True=表示する
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2018年03月04日
    '* 作成者　：井上　治
    '* 更新日　：2018年05月16日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Friend Function GetExcelInstance(ByRef objExcel As Object, _
                                     Optional ByVal blnNewInstance As Boolean = False, _
                                     Optional ByVal blnDispFatalError As Boolean = True) As Boolean
        '-------------------------------------------------------------------------------------------
        Dim typType As Type = Nothing                               ' Type
        objExcel = Nothing
        GetExcelInstance = False
        Try
            typType = Type.GetTypeFromProgID(g_cnsExcelApplication)
            ' 非インストールか
            If typType Is Nothing Then
                g_strFatalErrMSG = "Excelがインストールされていません。"
                ' エラー表示判定
                If blnDispFatalError Then
                    ' エラーを表示
                    MessageBox2.DialogShow(g_objOwnerForm, _
                                           g_strFatalErrMSG, _
                                           g_cnsProgTitle, _
                                           MessageBoxButtons.OK, _
                                           MessageBoxIcon.Error)
                End If
                Return False
            End If
        Catch ex As Exception
            ' 例外｢プロセス'{0}'が見つかりませんでした。｣の対策①(Try追加:想定対策)
            g_strFatalErrMSG = g_cnsExcelApplication & "の探索に失敗しました。" & ControlChars.CrLf & ex.Message
            If blnDispFatalError Then
                ' エラーを表示
                MessageBox2.DialogShow(g_objOwnerForm, _
                                       g_strFatalErrMSG, _
                                       g_cnsProgTitle, _
                                       MessageBoxButtons.OK, _
                                       MessageBoxIcon.Error)
                Return False
            End If
        End Try
        '-------------------------------------------------------------------------------------------
        Dim swNewInstance As Boolean = False                        ' 新規インスタンス指定
        ' 既存インスタンス指定か
        If Not blnNewInstance Then
            Try
                ' Excelが実行中の場合は実行中のインスタンスを取得
                ' ここで'System.Exception'の初回例外が発生しますがTry捕捉内なので無視します
                objExcel = GetObject(, g_cnsExcelApplication)
                GetExcelInstance = True
            Catch ex As Exception
                ' Excelが実行中でない(又は取得失敗)場合は新規にインスタンスを生成に切り替え
                swNewInstance = True
            End Try
        Else
            ' 新規にExcelインスタンスを生成
            swNewInstance = True
        End If
        ' 新規インスタンスか
        If swNewInstance Then
            Try
                objExcel = Activator.CreateInstance(typType)
                GetExcelInstance = True
            Catch ex As Exception
                g_strFatalErrMSG = g_cnsExcelApplication & "の起動に失敗しました。" & ControlChars.CrLf & ex.Message
                If blnDispFatalError Then
                    ' エラーを表示
                    MessageBox2.DialogShow(g_objOwnerForm, _
                                           g_strFatalErrMSG, _
                                           g_cnsProgTitle, _
                                           MessageBoxButtons.OK, _
                                           MessageBoxIcon.Error)
                    Return False
                End If
            End Try
        End If
        typType = Nothing
    End Function

    '***********************************************************************************************
    '* 処理名　：OpenWorkbook
    '* 機能　　：ワークブックを開く
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：処理正否(Boolean)
    '* 引数　　：Arg1 = ワークブックファイル名(String)   ※フルパスで指定
    '* 　　　　　Arg2 = Excel.Application(Object)
    '* 　　　　　Arg3 = Excel.Workbooks(Object)          ※Ref参照
    '* 　　　　　Arg4 = Excel.Workbook(Object)           ※Ref参照
    '* 　　　　　Arg5 = 引数UpdateLinks(Int16)           ※Option:Workbook時の引数
    '* 　　　　　Arg6 = 引数ReadOnly(Boolean)            ※Option:Workbook時の引数
    '* 　　　　　Arg7 = インスタンス生成(Boolean)        ※Option:True=新規インスタンス
    '* 　　　　　Arg8 = エラーメッセージ表示(Boolean)    ※Option:True=表示する
    '* 　　　　　Arg9 = Open時イベント状態(Boolean)      ※Option:True=イベント有効
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2018年03月04日
    '* 作成者　：井上　治
    '* 更新日　：2018年03月04日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：Excelのインスタンスが生成済である前提
    '***********************************************************************************************
    Friend Function OpenWorkbook(ByVal strExcelFileName As String, _
                                 ByRef objExcel As Object, _
                                 ByRef objWorkbooks As Object, _
                                 ByRef objWbk As Object, _
                                 Optional ByVal intUpdateLinks As Int16 = 0, _
                                 Optional ByVal blnReadOnly As Boolean = True, _
                                 Optional ByVal blnNewInstance As Boolean = False, _
                                 Optional ByVal blnDispFatalError As Boolean = True, _
                                 Optional ByVal blnEnableEvents As Boolean = True) As Boolean
        '-------------------------------------------------------------------------------------------
        ' Workbooksの取得
        If objWorkbooks Is Nothing Then
            Try
                objWorkbooks = objExcel.Workbooks
            Catch ex As Exception
                g_strFatalErrMSG = "Excelワークブックが開けませんでした。" & vbCrLf & ex.Message & vbCrLf & vbCrLf & _
                    "※セル内編集中、マクロ実行中の場合は状態解除後に再実行して下さい。"
                If blnDispFatalError Then
                    ' エラーを表示
                    MessageBox2.DialogShow(g_objOwnerForm, _
                                           g_strFatalErrMSG, _
                                           g_cnsProgTitle, _
                                           MessageBoxButtons.OK, _
                                           MessageBoxIcon.Error)
                End If
                Return False
            End Try
        End If
        '===========================================================================================
        ' 指定のワークブックを開く
        '-------------------------------------------------------------------------------------------
        Dim strExtU As String = Path.GetExtension(strExcelFileName).ToUpper ' 拡張子(大文字)
        Dim objWbk2 As Object = Nothing                             ' ワークブック(WORK)
        Dim blnFind As Boolean = False                              ' 既存発見
        ' 初期イベント状態
        objExcel.EnableEvents = blnEnableEvents
#If DEBUG Then
        '-------------------------------------------------------------------------------------------
        ' デバッグモードではエラー処置なし
        If ((strExtU = g_cnsXlt) OrElse (strExtU = g_cnsXltm) OrElse (strExtU = g_cnsXltx)) Then
            ' テンプレート(*.xlt,*.xltm,*.xltx)時は新規ブックで開く
            objWbk = objWorkbooks.Add(strExcelFileName)
            blnFind = True
        Else
            ' ワークブック(*.xls,*.xlsm,*.xlsx)等の場合は既に開いているか判断
            For Each objWbk2 In objWorkbooks
                ' フルネームの一致はそのファイルの処理とする(正常扱い)
                If objWbk2.FullName = strExcelFileName Then
                    objWbk = objWbk2
                    blnFind = True
                    Exit For
                End If
            Next objWbk2
            ' 見つからなければ新規に開く
            If Not blnFind Then
                ' ワークブック(*.xls等)時は開く
                objWbk = objWorkbooks.Open(strExcelFileName, intUpdateLinks, blnReadOnly)
                blnFind = True
            End If
        End If
        Return blnFind
#Else
        '-------------------------------------------------------------------------------------------
        ' リリースモードではエラー処理を行なう
        Try
            If ((strExtU = g_cnsXLT) OrElse (strExtU = g_cnsXLTM) OrElse (strExtU = g_cnsXLTX)) Then
                ' テンプレート(*.xlt,*.xltm,*.xltx)時は新規ブックで開く
                objWbk = objWorkbooks.Add(strExcelFileName)
                blnFind = True
            Else
                ' ワークブック(*.xls,*.xlsm,*.xlsx)等の場合は既に開いているか判断
                For Each objWbk2 In objWorkbooks
                    ' フルネームの一致はそのファイルの処理とする(正常扱い)
                    If objWbk2.FullName = strExcelFileName Then
                        objWbk = objWbk2
                        blnFind = True
                        Exit For
                    End If
                Next objWbk2
                ' 見つからなければ新規に開く
                If Not blnFind Then
                    ' ワークブック(*.xls等)時は開く
                    objWbk = objWorkbooks.Open(strExcelFileName, intUpdateLinks, blnReadOnly)
                    blnFind = True
                End If
            End If
            Return blnFind
        Catch ex As Exception
            g_strFatalErrMSG = "指定ワークブックが開けません。" & ControlChars.CrLf & ex.Message & ControlChars.CrLf & strExcelFileName
            If blnDispFatalError Then
                ' エラーを表示
                MessageBox2.DialogShow(g_objOwnerForm, _
                                       g_strFatalErrMSG, _
                                       g_cnsProgTitle, _
                                       MessageBoxButtons.OK, _
                                       MessageBoxIcon.Error)
            End If
            ' ブックエラー時はExcelインスタンスを解放
            If blnNewInstance Then objExcel.Quit()
            Call GP_ReleaseComObject(objExcel)
        End Try
#End If
    End Function

    '***********************************************************************************************
    '* 処理名　：GetWorksheet
    '* 機能　　：ワークシートオブジェクト取得
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：処理結果(Boolean)                       ※Trueは正常
    '* 引数　　：Arg1 = Excel.Workbook(Object)
    '* 　　　　　Arg2 = Excel.Worksheets(Object)         ※Ref参照
    '* 　　　　　Arg3 = Excel.Worksheet(Object)          ※Ref参照
    '* 　　　　　Arg4 = ワークシート名(String)           ※ブランクの場合はOptionに従う
    '* 　　　　　Arg5 = シート№(Integer)                ※Option:シート名ブランク時に参照する№を指定
    '* 　　　　　Arg6 = エラーメッセージ表示(Boolean)    ※Option:True=表示する
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2012年08月22日
    '* 作成者　：井上　治
    '* 更新日　：2018年03月04日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：本処理ではエラーメッセージの表示は行ないません
    '***********************************************************************************************
    Friend Function GetWorksheet(ByRef objWbk As Object, _
                                 ByRef objWorksheets As Object, _
                                 ByRef objSh As Object, _
                                 ByVal strSheetName As String, _
                                 Optional ByVal intNo As Integer = 1, _
                                 Optional ByVal blnDispFatalError As Boolean = True) As Boolean
        '-------------------------------------------------------------------------------------------
        Try
            ' Worksheetsの取得
            If objWorksheets Is Nothing Then
                objWorksheets = objWbk.Worksheets
            End If
            ' ワークシート名の指定があるか
            If strSheetName.Length <> 0 Then
                objSh = objWorksheets(strSheetName)
            Else
                strSheetName = "処理対象"
                objSh = objWorksheets(intNo)
            End If
            GetWorksheet = True
        Catch ex As Exception
            g_strFatalErrMSG = strSheetName & "シートが参照できません。" & ControlChars.CrLf & ex.Message
            If blnDispFatalError Then
                ' エラーを表示
                MessageBox2.DialogShow(g_objOwnerForm, _
                                       g_strFatalErrMSG, _
                                       g_cnsProgTitle, _
                                       MessageBoxButtons.OK, _
                                       MessageBoxIcon.Error)
            End If
            Return False
        End Try
    End Function

    '***********************************************************************************************
    '* 処理名　：SuspendExcelProc
    '* 機能　　：Excel出力の終了
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = Excel.Application(Object)
    '* 　　　　　Arg2 = Excel.Workbook(Object)
    '* 　　　　　Arg3 = 終了回避スイッチ(Boolean)        ※Option:True=Excel終了しない
    '* 　　　　　Arg4 = 保存済回避スイッチ(Boolean)      ※Option:True=保存済にしない
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年04月16日
    '* 作成者　：井上　治
    '* 更新日　：2018年05月16日
    '* 更新者　：井上　治
    '* 機能説明：WorkbookのCloseやExcelの終了を含む(Excelを表示させて終了も可)
    '* 注意事項：この処理中での例外は無視される
    '***********************************************************************************************
    Friend Sub SuspendExcelProc(ByRef objExcel As Object, _
                                ByRef objWbk As Object, _
                                Optional ByVal blnOmitQuit As Boolean = False, _
                                Optional ByVal blnOmitSaved As Boolean = False)
        '-------------------------------------------------------------------------------------------
        ' 閉じない指定でなければブックを閉じる
        If objWbk IsNot Nothing AndAlso Not blnOmitQuit Then
            Try
                With objExcel
                    .Calculation = xlCalculationAutomatic
                    '.EnableEvents = True   ' ←BeforeCloseイベントが動いてしまう
                    .ScreenUpdating = True
                End With
                objWbk.Saved = True                     ' 展開ブックは保存済み属性とする
                objWbk.Close(False)
            Finally
                ' COMオブジェクト解放
                Call GP_ReleaseComObject(objWbk)
            End Try
        End If
        Application.DoEvents()
        '-------------------------------------------------------------------------------------------
        ' 他ブックがExcelインスタンス上で開いているか判定
        Dim objWorkbooks As Object = objExcel.Workbooks             ' Workbooks
        If objWorkbooks.Count <> 0 Then
            ' 処理中ブックClose後でも別のワークブックが存在する
            blnOmitQuit = True
        End If
        ' COMオブジェクトの解放(Excel.Workbooks)
        Call GP_ReleaseComObject(objWorkbooks)
        Application.DoEvents()
        '-------------------------------------------------------------------------------------------
        ' Excelインスタンスの処置
        Try
            ' Application解放
            If Not blnOmitQuit Then
                ' Excelの終了
                Call QuitExcelProc(objExcel)
            Else
                ' Excelの現状復帰(表示再開等)
                objExcel.Visible = True             ' Excelウィンドウを表示
                If objExcel.WindowState = xlMinimized Then
                    ' 最小化状態だったら通常に復帰
                    objExcel.WindowState = xlNormal
                End If
                Call ExcelStartScreenUpdate(objExcel)
            End If
        Finally
            ' COMオブジェクト解放
            If Not blnOmitQuit Then
                Call GP_ReleaseComObject(objExcel)
            End If
        End Try
    End Sub

    '***********************************************************************************************
    '* 処理名　：QuitExcelProc
    '* 機能　　：Excel終了(強制終了)
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = Excel.Application(Object)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年04月16日
    '* 作成者　：井上　治
    '* 更新日　：2018年05月16日
    '* 更新者　：井上　治
    '* 機能説明：動作不良でない限りExcelを強制的に終了させる
    '* 注意事項：この処理中での例外は無視される
    '***********************************************************************************************
    Friend Sub QuitExcelProc(ByRef objExcel As Object)
        '-------------------------------------------------------------------------------------------
        Application.DoEvents()
        Try
            Dim objWorkbooks As Object = objExcel.Workbooks         ' Workbooks
            Dim objWbk As Object = Nothing                          ' Workbook
            ' 開いているブックがExcelインスタンス上にあれば閉じる
            For Each objWbk In objWorkbooks
                objWbk.Saved = True
                objWbk.Close(False)
            Next objWbk
            Call GP_ReleaseComObject(objWbk)
            ' Excelの終了
            objExcel.Quit()
            Application.DoEvents()
            Call GP_ReleaseComObject(objExcel)
        Catch ex As Exception
            ' 無視
        End Try
    End Sub

    '***********************************************************************************************
    '* 処理名　：ExcelStopScreenUpdate
    '* 機能　　：Excelの画面描画停止
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = Excel.Application(Object)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2011年02月02日
    '* 作成者　：井上　治
    '* 更新日　：2011年02月02日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Friend Sub ExcelStopScreenUpdate(ByRef objExcel As Object)
        '-------------------------------------------------------------------------------------------
        With objExcel
            .ScreenUpdating = False
            .Calculation = xlCalculationManual
            .EnableEvents = False
        End With
    End Sub

    '***********************************************************************************************
    '* 処理名　：ExcelStartScreenUpdate
    '* 機能　　：Excelの画面描画停止
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = Excel.Application(Object)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2011年02月02日
    '* 作成者　：井上　治
    '* 更新日　：2011年02月02日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Friend Sub ExcelStartScreenUpdate(ByRef objExcel As Object)
        '-------------------------------------------------------------------------------------------
        With objExcel
            .Calculation = xlCalculationAutomatic
            .EnableEvents = True
            .ScreenUpdating = True
        End With
    End Sub

    '***********************************************************************************************
    '* 処理名　：ReleaseComObject
    '* 機能　　：COMオブジェクトの解放
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = COMオブジェクト(Object)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年04月16日
    '* 作成者　：井上　治
    '* 更新日　：2017年04月16日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Friend Sub ReleaseComObject(ByRef objCOM As Object)
        '-------------------------------------------------------------------------------------------
        ' COMオブジェクトの解放(共通処理)
        Call GP_ReleaseComObject(objCOM)
    End Sub

    '***********************************************************************************************
    '* 処理名　：ShowFatalMessage
    '* 機能　　：致命例外メッセージ編集
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = プログラムタイトル(String)
    '* 　　　　　Arg2 = メッセージヘッダ(String)
    '* 　　　　　Arg3 = 例外メッセージ(String)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年04月16日
    '* 作成者　：井上　治
    '* 更新日　：2017年04月16日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Friend Sub ShowFatalMessage(ByVal strTitle As String, _
                                ByVal strMSGHeader As String, _
                                ByVal strExMessage As String)
        '-------------------------------------------------------------------------------------------
        Dim strErrMSG As String = strMSGHeader                      ' メッセージ
        ' ヘッダ無し
        If strMSGHeader.Length = 0 Then
            strErrMSG = strExMessage
        Else
            strErrMSG &= "でエラーが発生しました。" & ControlChars.CrLf & strExMessage
            strErrMSG &= ControlChars.CrLf & ControlChars.CrLf
            strErrMSG &= "Excelプロセスが残存する場合があります。" & ControlChars.CrLf
            strErrMSG &= "不具合が解消しない場合はWindowsを再起動して下さい。"
        End If
        MessageBox2.DialogShow(g_objOwnerForm, _
                               strErrMSG, _
                               strTitle, _
                               MessageBoxButtons.OK, _
                               MessageBoxIcon.Error)
    End Sub

    '***********************************************************************************************
    ' ■■■ 共通サブ処理(Private) ■■■
    '***********************************************************************************************
    '* 処理名　：GP_ReleaseComObject
    '* 機能　　：COMオブジェクトの解放
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = COMオブジェクト(Object)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年04月16日
    '* 作成者　：井上　治
    '* 更新日　：2017年04月16日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Sub GP_ReleaseComObject(ByRef objCOM As Object)
        '-------------------------------------------------------------------------------------------
        ' 明示的にCOMオブジェクトへの参照を解放する
        Try
            ' ランタイム呼び出し可能ラッパーの参照カウントをデクリメント
            If ((Not objCOM Is Nothing) AndAlso (Marshal.IsComObject(objCOM))) Then
                Marshal.FinalReleaseComObject(objCOM)
            End If
        Finally
            ' 参照を解除する
            objCOM = Nothing
        End Try
    End Sub

    '***********************************************************************************************
    '   ■■■ プロパティ ■■■
    '***********************************************************************************************
    '   処理中断スイッチ(Boolean)
    '-----------------------------------------------------------------------------------------------
    Friend Property prpPrintCancel() As Boolean
        Get
            Return g_swPrintCancel
        End Get
        Set(ByVal value As Boolean)
            g_swPrintCancel = value
        End Set
    End Property

    '===============================================================================================
    '   出力処理中スイッチ(Boolean)
    '-----------------------------------------------------------------------------------------------
    Friend Property prpExcelDuringProc() As Boolean
        Get
            Return g_swExcelDuringProc
        End Get
        Set(ByVal value As Boolean)
            g_swExcelDuringProc = value
        End Set
    End Property

    '===============================================================================================
    '   ブックOPEN時のイベント状態(イベント停止する場合はFP_GetWorkbookを呼ぶ前にFalseにする)
    '-----------------------------------------------------------------------------------------------
    Friend Property prpExcelEnableEvents() As Boolean
        Get
            Return g_swExcelEnableEvents
        End Get
        Set(ByVal value As Boolean)
            g_swExcelEnableEvents = value
        End Set
    End Property

    '===============================================================================================
    '   致命エラーメッセージ(String)
    '-----------------------------------------------------------------------------------------------
    Friend ReadOnly Property prpFatalErrMSG As String
        Get
            Return g_strFatalErrMSG
        End Get
    End Property

    '---------------------------------------<< End of Source >>-------------------------------------
End Class
